Index: main/plugin-survey/src/org/ametys/plugins/survey/repository/SurveyPage.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/repository/SurveyPage.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/repository/SurveyPage.java	(working copy)
@@ -15,12 +15,16 @@
  */
 package org.ametys.plugins.survey.repository;
 
+import java.io.InputStream;
+import java.util.Date;
 import java.util.List;
 
 import javax.jcr.Node;
 import javax.jcr.PathNotFoundException;
 import javax.jcr.RepositoryException;
 
+import org.apache.commons.lang.StringUtils;
+
 import org.ametys.plugins.repository.AmetysObject;
 import org.ametys.plugins.repository.AmetysObjectIterable;
 import org.ametys.plugins.repository.AmetysRepositoryException;
@@ -28,6 +32,9 @@
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
 import org.ametys.plugins.repository.RepositoryConstants;
 import org.ametys.plugins.repository.jcr.DefaultTraversableAmetysObject;
+import org.ametys.plugins.repository.metadata.BinaryMetadata;
+import org.ametys.plugins.repository.metadata.ModifiableBinaryMetadata;
+import org.ametys.plugins.repository.metadata.ModifiableCompositeMetadata;
 import org.ametys.plugins.survey.repository.SurveyRule.RuleType;
 
 /**
@@ -45,6 +52,14 @@
     private static final String __METADATA_RULE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":rule";
     private static final String __METADATA_RULE_TYPE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":rule";
     private static final String __METADATA_RULE_PAGE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":page";
+    /** Constant for picture type metadata. */
+    private static final String __METADATA_PICTURE_TYPE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-type";
+    /** Constant for picture data metadata. */
+    private static final String __METADATA_PICTURE = "picture";
+    /** Constant for picture id metadata. */
+    private static final String __METADATA_PICTURE_ID = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-id";
+    /** Constant for picture alternative metadata. */
+    private static final String __METADATA_PICTURE_ALTERNATIVE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-alternative";
     
     /**
      * Creates a {@link SurveyPage}.
@@ -309,6 +324,192 @@
         return getChildren();
     }
     
+    /**
+     * Get the picture as a binary metadata.
+     * @return the picture as a binary metadata.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public BinaryMetadata getExternalPicture() throws AmetysRepositoryException
+    {
+        return getMetadataHolder().getBinaryMetadata(__METADATA_PICTURE);
+    }
+    
+    /**
+     * Set the picture from an external file.
+     * @param mimeType the file MIME type.
+     * @param filename the file name.
+     * @param stream an input stream on the file bytes.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setExternalPicture(String mimeType, String filename, InputStream stream) throws AmetysRepositoryException
+    {
+        try
+        {
+            removePictureMetas();
+            
+            setPictureType("external");
+            
+            ModifiableCompositeMetadata meta = getMetadataHolder();
+            ModifiableBinaryMetadata pic = meta.getBinaryMetadata(__METADATA_PICTURE, true);
+            
+            pic.setLastModified(new Date());
+            pic.setInputStream(stream);
+            pic.setMimeType(mimeType);
+            pic.setFilename(filename);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the external picture property.", e);
+        }
+    }
+    
+    /**
+     * Get the picture resource ID.
+     * @return the resource ID.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getResourcePictureId() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_ID).getString();
+        }
+        catch (PathNotFoundException e)
+        {
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the picture ID property.", e);
+        }
+    }
+        
+    /**
+     * Set the picture from an explorer resource.
+     * @param resourceId the resource ID.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setResourcePicture(String resourceId) throws AmetysRepositoryException
+    {
+        try
+        {
+            removePictureMetas();
+            
+            setPictureType("resource");
+            
+            getNode().setProperty(__METADATA_PICTURE_ID, resourceId);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Removes any picture currently assigned.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setNoPicture() throws AmetysRepositoryException
+    {
+        try
+        {
+            setPictureType("");
+            
+            removePictureMetas();
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+
+    /**
+     * Get the picture type.
+     * @return the picture type.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getPictureType() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_TYPE).getString();
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the type property.", e);
+        }
+    }
+    
+    /**
+     * Set the picture type.
+     * @param type the picture type to set.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setPictureType(String type) throws AmetysRepositoryException
+    {
+        try
+        {
+            getNode().setProperty(__METADATA_PICTURE_TYPE, type);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the type property.", e);
+        }
+    }
+    
+    /**
+     * Get the picture alternative.
+     * @return the picture alternative.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getPictureAlternative() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_ALTERNATIVE).getString();
+        }
+        catch (PathNotFoundException e)
+        {
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Set the picture alternative.
+     * @param alternative the picture alternative to set.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setPictureAlternative(String alternative) throws AmetysRepositoryException
+    {
+        try
+        {
+            getNode().setProperty(__METADATA_PICTURE_ALTERNATIVE, alternative);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Remove all picture metas (picture ID and picture binary).
+     * @throws RepositoryException if an error occurs.
+     */
+    protected void removePictureMetas() throws RepositoryException
+    {
+        getNode().setProperty(__METADATA_PICTURE_ID, "");
+        
+        ModifiableCompositeMetadata meta = getMetadataHolder();
+        if (meta.hasMetadata(__METADATA_PICTURE))
+        {
+            meta.removeMetadata(__METADATA_PICTURE);
+        }
+    }
+    
     @Override
     public SurveyPage copyTo(ModifiableTraversableAmetysObject parent, String name) throws AmetysRepositoryException
     {
@@ -322,6 +523,35 @@
             page.setDescription(description);
         }
         
+        String pictureType = getPictureType();
+        if (StringUtils.isBlank(pictureType))
+        {
+            page.setNoPicture();
+        }
+        else if (pictureType.equals("resource"))
+        {
+            String pictureId = getResourcePictureId();
+            if (StringUtils.isNotBlank(pictureId))
+            {
+                page.setResourcePicture(pictureId);
+            }
+            else
+            {
+                page.setNoPicture();
+            }
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata externalPicture = getExternalPicture();
+            page.setExternalPicture(externalPicture.getMimeType(), externalPicture.getFilename(), externalPicture.getInputStream());
+        }
+        
+        String pictureAlternative = getPictureAlternative();
+        if (pictureAlternative != null)
+        {
+            page.setPictureAlternative(pictureAlternative);
+        }
+        
         SurveyRule rule = getRule();
         if (rule != null)
         {
Index: main/plugin-survey/src/org/ametys/plugins/survey/repository/SurveyQuestion.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/repository/SurveyQuestion.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/repository/SurveyQuestion.java	(working copy)
@@ -15,6 +15,8 @@
  */
 package org.ametys.plugins.survey.repository;
 
+import java.io.InputStream;
+import java.util.Date;
 import java.util.LinkedHashMap;
 import java.util.LinkedList;
 import java.util.List;
@@ -33,6 +35,9 @@
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
 import org.ametys.plugins.repository.RepositoryConstants;
 import org.ametys.plugins.repository.jcr.DefaultTraversableAmetysObject;
+import org.ametys.plugins.repository.metadata.BinaryMetadata;
+import org.ametys.plugins.repository.metadata.ModifiableBinaryMetadata;
+import org.ametys.plugins.repository.metadata.ModifiableCompositeMetadata;
 import org.ametys.plugins.survey.repository.SurveyRule.RuleType;
 
 /**
@@ -65,6 +70,14 @@
     private static final String __METADATA_RULE_TYPE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":rule";
     private static final String __METADATA_RULE_OPTION = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":option";
     private static final String __METADATA_RULE_PAGE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":page";
+    /** Constant for picture type metadata. */
+    private static final String __METADATA_PICTURE_TYPE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-type";
+    /** Constant for picture data metadata. */
+    private static final String __METADATA_PICTURE = "picture";
+    /** Constant for picture id metadata. */
+    private static final String __METADATA_PICTURE_ID = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-id";
+    /** Constant for picture alternative metadata. */
+    private static final String __METADATA_PICTURE_ALTERNATIVE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-alternative";
     
     /** Type of a page. */
     public enum QuestionType
@@ -616,6 +629,192 @@
         return getSurveyPage().getSurvey();
     }
     
+    /**
+     * Get the picture as a binary metadata.
+     * @return the picture as a binary metadata.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public BinaryMetadata getExternalPicture() throws AmetysRepositoryException
+    {
+        return getMetadataHolder().getBinaryMetadata(__METADATA_PICTURE);
+    }
+    
+    /**
+     * Set the picture from an external file.
+     * @param mimeType the file MIME type.
+     * @param filename the file name.
+     * @param stream an input stream on the file bytes.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setExternalPicture(String mimeType, String filename, InputStream stream) throws AmetysRepositoryException
+    {
+        try
+        {
+            removePictureMetas();
+            
+            setPictureType("external");
+            
+            ModifiableCompositeMetadata meta = getMetadataHolder();
+            ModifiableBinaryMetadata pic = meta.getBinaryMetadata(__METADATA_PICTURE, true);
+            
+            pic.setLastModified(new Date());
+            pic.setInputStream(stream);
+            pic.setMimeType(mimeType);
+            pic.setFilename(filename);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the external picture property.", e);
+        }
+    }
+    
+    /**
+     * Get the picture resource ID.
+     * @return the resource ID.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getResourcePictureId() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_ID).getString();
+        }
+        catch (PathNotFoundException e)
+        {
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the picture ID property.", e);
+        }
+    }
+        
+    /**
+     * Set the picture from an explorer resource.
+     * @param resourceId the resource ID.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setResourcePicture(String resourceId) throws AmetysRepositoryException
+    {
+        try
+        {
+            removePictureMetas();
+            
+            setPictureType("resource");
+            
+            getNode().setProperty(__METADATA_PICTURE_ID, resourceId);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Removes any picture currently assigned.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setNoPicture() throws AmetysRepositoryException
+    {
+        try
+        {
+            setPictureType("");
+            
+            removePictureMetas();
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+
+    /**
+     * Get the picture type.
+     * @return the picture type.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getPictureType() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_TYPE).getString();
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the type property.", e);
+        }
+    }
+    
+    /**
+     * Set the picture type.
+     * @param type the picture type to set.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setPictureType(String type) throws AmetysRepositoryException
+    {
+        try
+        {
+            getNode().setProperty(__METADATA_PICTURE_TYPE, type);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the type property.", e);
+        }
+    }
+    
+    /**
+     * Get the picture alternative.
+     * @return the picture alternative.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getPictureAlternative() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_ALTERNATIVE).getString();
+        }
+        catch (PathNotFoundException e)
+        {
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Set the picture alternative.
+     * @param alternative the picture alternative to set.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setPictureAlternative(String alternative) throws AmetysRepositoryException
+    {
+        try
+        {
+            getNode().setProperty(__METADATA_PICTURE_ALTERNATIVE, alternative);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Remove all picture metas (picture ID and picture binary).
+     * @throws RepositoryException if an error occurs.
+     */
+    protected void removePictureMetas() throws RepositoryException
+    {
+        getNode().setProperty(__METADATA_PICTURE_ID, "");
+        
+        ModifiableCompositeMetadata meta = getMetadataHolder();
+        if (meta.hasMetadata(__METADATA_PICTURE))
+        {
+            meta.removeMetadata(__METADATA_PICTURE);
+        }
+    }
+    
     @Override
     public SurveyQuestion copyTo(ModifiableTraversableAmetysObject parent, String name) throws AmetysRepositoryException
     {
@@ -625,6 +824,35 @@
         question.setMandatory(isMandatory());
         question.setType(getType());
         
+        String pictureType = getPictureType();
+        if (StringUtils.isBlank(pictureType))
+        {
+            question.setNoPicture();
+        }
+        else if (pictureType.equals("resource"))
+        {
+            String pictureId = getResourcePictureId();
+            if (StringUtils.isNotBlank(pictureId))
+            {
+                question.setResourcePicture(pictureId);
+            }
+            else
+            {
+                question.setNoPicture();
+            }
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata externalPicture = getExternalPicture();
+            question.setExternalPicture(externalPicture.getMimeType(), externalPicture.getFilename(), externalPicture.getInputStream());
+        }
+        
+        String pictureAlternative = getPictureAlternative();
+        if (pictureAlternative != null)
+        {
+            question.setPictureAlternative(pictureAlternative);
+        }
+        
         String regExpType = getRegExpType();
         if (StringUtils.isNotEmpty(regExpType))
         {
